%include "CScintilla.inc"

; this = ebp
; member(x) = [this+sCScintilla.x]

align 4
global CScintilla@OnDestroy

CScintilla@OnDestroy: ; shared method with constructor; scintilla will be destroyed by the system
METHOD CScintilla, 0
	sub   eax,eax
	mov   member(m_fn),eax
	mov   member(m_ptr),eax
	mov   member(m_hSci),eax
ENDMETHOD


METHOD Create, 8 uses esi,edi; left, top, width, height, style, exstyle, title, parent
	%define left    0
	%define top     1
	%define width   2
	%define height  3
	%define style   4
	%define exstyle 5
	%define title   6
	%define parent  7

	invoke GetModuleHandleA, $szDllName
	and    eax,eax
	jnz   .create
	invoke LoadLibraryA, $szDllName
	and    eax,eax
	jz     near .q
.create:
	mov    esi,arg(parent)
	xor    edx,edx
	; we use esp based stack frame, so the '7' in arg(left,7) handles six already pushed arguments
	invoke CWindow@Create,this, arg(left,7),arg(top,6),arg(width,5),arg(height,4),arg(style,3),arg(exstyle,2),edx,esi
	xor    edx,edx
	invoke CreateWindowExA, edx,$szControlClassName,arg(title,9),0x50000000,arg(left,7),arg(top,6),arg(width,5),arg(height,4),member(m_hwnd),edx,[_hinstance],edx
	mov    edi,eax
	xor    esi,esi
	and    edi,edi
	mov    member(m_hSci),edi
	jz    .q
	invoke SendMessageA,  edi, SCI_GETDIRECTFUNCTION, esi,esi
	mov    member(m_ptr),eax
	invoke SendMessageA,  edi, SCI_GETDIRECTPOINTER, esi,esi
	mov    member(m_fn),eax
	mov    eax,edi
.q:
ENDMETHOD

;-------------------------------------------------
METHOD OnControl, 3 ; id, code, hwnd
	; from scintilla ?
	mov   eax,arg(2)
	cmp   eax,member(m_hSci)
	jne   .q
	mov   edx,arg(1)

	mov   ecx,CScintilla_OnChange ; virtual method offset
	cmp   edx,SCEN_CHANGE
	je   .ok
	mov   ecx,CScintilla_OnScSetFocus
	cmp   edx,SCEN_SETFOCUS
	je   .ok
	mov   ecx,CScintilla_OnScKillFocus
	cmp   edx,SCEN_KILLFOCUS
	jne  .q
.ok:
	coinvoke this,ecx      ; execute WM_COMMAND virtual method On*

	; notify parent window
	invoke GetParent, member(m_hwnd)
	and    eax,eax
	jz    .q
	%define WM_COMMAND 0x111
	mov    dx,arg(1)
	shl    edx,16
	mov    dx,arg(0)
	invoke SendMessageA,eax,WM_COMMAND,edx,arg(2)
.q:
ENDMETHOD

;------------------------------------------------- invalid (deprecated) code: 2012
METHOD OnNotify, 3 ; code,nID,pnmhdr
	%define code   0
	%define nID    1
	%define pnmhdr 2
	; from scintilla ?
	mov    eax,arg(pnmhdr)
	mov    eax,[eax] ; hwndFrom
	cmp    eax,member(m_hSci)
	jne   .q

	mov    edx,arg(code)          ; edx used as virtual method offset
	cmp    dx,SCN_STYLENEEDED     ; range min
	jb    .q
	cmp    edx,SCN_AUTOCSELECTION ; range max
	ja    .q
	xor    ecx,ecx
	cmp    edx,2012                ; if code>=2012  edx--
	setae  cl
	sub    dx,cx

	; create virtual method offsset
	sub    dx,SCN_STYLENEEDED          ; offset it: edx = code-SCN_STYLENEEDED (SCN_STYLENEEDED is the first notification)
	add    dx,dx                       ; multiply by 4
	add    dx,dx
	add    dx,CScintilla_OnStyleNeeded ; add first scintilla virtual method offsset
	coinvoke this,edx,arg(pnmhdr)      ; execute WM_NOTIFY virtual method On*

	; notify parent window
	invoke GetParent, member(m_hwnd)
	and    eax,eax
	jz    .q
	%define WM_NOTIFY 0x4E
	invoke SendMessageA,eax,WM_NOTIFY,arg(nID,1),arg(pnmhdr)
.q:
ENDMETHOD

;-------------------------------------------------
METHOD OnSize, 3 ; type,x,y
	xor    eax,eax
	invoke MoveWindow, member(m_hSci), eax,eax,arg(1,2),arg(2,1),1
ENDMETHOD

;-------------------------------------------------
align 4
global CScintilla@SetText
CScintilla@SetText:
	jmp CScintilla@SciSetText

;-------------------------------------------------
METHOD GetText, 0
	mov   eax,member(m_hSci)
	and   eax,eax
	jnz  .ok
.err:
	invoke AllocHeap,4
	jmp   .q
.ok:
	call   CScintilla@GetTextLength,this
	inc    eax
	push   eax
	invoke AllocHeap,eax
	pop    edx
	and    eax,eax
	jz    .err
	push   eax
	call   CScintilla@GetText,this,edx,eax
	pop    eax
.q:
ENDMETHOD


;-------------------------------------------------









MAKEMETHOD SCI_ADDTEXT,					2001, AddText, 1, 2
MAKEMETHOD SCI_ADDSTYLEDTEXT,			2002, AddStyledText, 1, 2
MAKEMETHOD SCI_INSERTTEXT,				2003, InsertText,1, 2
MAKEMETHOD SCI_CLEARALL,				2004, ClearAll
MAKEMETHOD SCI_CLEARDOCUMENTSTYLE,		2005, ClearDocumentStyle
MAKEMETHOD SCI_GETLENGTH,				2006, GetLength
MAKEMETHOD SCI_GETCHARAT, 				2007, GetCharAt, 1
MAKEMETHOD SCI_GETCURRENTPOS, 			2008, GetCurrentPos
MAKEMETHOD SCI_GETANCHOR, 				2009, GetAnchor
MAKEMETHOD SCI_GETSTYLEAT, 				2010, GetStyleAt, 1
MAKEMETHOD SCI_REDO, 					2011, Redo
MAKEMETHOD SCI_SETUNDOCOLLECTION, 		2012, SetUndoCollection, 1
MAKEMETHOD SCI_SELECTALL, 				2013, SelectAll
MAKEMETHOD SCI_SETSAVEPOINT, 			2014, SetSavePoint
MAKEMETHOD SCI_GETSTYLEDTEXT, 			2015, GetStyledText, 0, 1
MAKEMETHOD SCI_CANREDO, 				2016, CanRedo
MAKEMETHOD SCI_MARKERLINEFROMHANDLE,	2017, MarkerLineFromHandle, 1
MAKEMETHOD SCI_MARKERDELETEHANDLE, 		2018, MarkerDeleteHandle, 1
MAKEMETHOD SCI_GETUNDOCOLLECTION, 		2019, GetUndoCollection
MAKEMETHOD SCI_GETVIEWWS, 				2020, GetViewWS
MAKEMETHOD SCI_SETVIEWWS, 				2021, SetViewWS, 1
MAKEMETHOD SCI_POSITIONFROMPOINT, 		2022, PositionFromPoint, 1, 2
MAKEMETHOD SCI_POSITIONFROMPOINTCLOSE,	2023, PositionFromPointClose, 1, 2
MAKEMETHOD SCI_GOTOLINE, 				2024, GotoLine, 1
MAKEMETHOD SCI_GOTOPOS, 				2025, GotoPos, 1
MAKEMETHOD SCI_SETANCHOR, 				2026, SetAnchor, 1
MAKEMETHOD SCI_GETCURLINE, 				2027, GetCurLine, 1, 2
MAKEMETHOD SCI_GETENDSTYLED, 			2028, GetEndStyled
MAKEMETHOD SCI_CONVERTEOLS, 			2029, ConvertEols, 1
MAKEMETHOD SCI_GETEOLMODE, 				2030, GetEolMode
MAKEMETHOD SCI_SETEOLMODE, 				2031, SetEolMode, 1
MAKEMETHOD SCI_STARTSTYLING, 			2032, StartStyling, 1, 2
MAKEMETHOD SCI_SETSTYLING, 				2033, SetStyling, 1, 2
MAKEMETHOD SCI_GETBUFFEREDDRAW, 		2034, GetBufferedDraw
MAKEMETHOD SCI_SETBUFFEREDDRAW, 		2035, SetBufferedDraw, 1
MAKEMETHOD SCI_SETTABWIDTH, 			2036, SetTabWidth, 1

MAKEMETHOD SCI_SETCODEPAGE, 			2037, SetCodePage,1
MAKEMETHOD SCI_SETUSEPALETTE, 			2039, SetUsePalette, 1
MAKEMETHOD SCI_MARKERDEFINE, 			2040, MarkerDefine, 1, 2
MAKEMETHOD SCI_MARKERSETFORE, 			2041, MarkerSetFore, 1, 2
MAKEMETHOD SCI_MARKERSETBACK, 			2042, MarkerSetBack, 1, 2
MAKEMETHOD SCI_MARKERADD, 				2043, MarkerAdd, 1, 2
MAKEMETHOD SCI_MARKERDELETE, 			2044, MarkerDelete, 1, 2
MAKEMETHOD SCI_MARKERDELETEALL, 		2045, MarkerDeleteAll, 1
MAKEMETHOD SCI_MARKERGET, 				2046, MarkerGet, 1
MAKEMETHOD SCI_MARKERNEXT, 				2047, MarkerNext, 1, 2
MAKEMETHOD SCI_MARKERPREVIOUS, 			2048, MarkerPrevious, 1, 2
MAKEMETHOD SCI_MARKERDEFINEPIXMAP,		2049, MarkerDefinePixmap, 1, 2
MAKEMETHOD SCI_MARKERADDSET,			2466, MarkerAddSet, 1, 2
MAKEMETHOD SCI_SETMARGINTYPEN,			2240, SetMarginTypeN, 1, 2
MAKEMETHOD SCI_GETMARGINTYPEN,			2241, GetMarginTypeN, 1
MAKEMETHOD SCI_SETMARGINWIDTHN,			2242, SetMarginWidthN, 1, 2
MAKEMETHOD SCI_GETMARGINWIDTHN,			2243, GetMarginWidthN, 1
MAKEMETHOD SCI_SETMARGINMASKN,			2244, SetMarginMaskN, 1, 2
MAKEMETHOD SCI_GETMARGINMASKN,			2245, GetMarginMaskN, 1
MAKEMETHOD SCI_SETMARGINSENSITIVEN,		2246, SetMarginSensitiveN, 1, 2
MAKEMETHOD SCI_GETMARGINSENSITIVEN,		2247, GetMarginSensitiveN, 1
MAKEMETHOD SCI_STYLECLEARALL,			2050, StyleClearAll
MAKEMETHOD SCI_STYLESETFORE, 			2051, StyleSetFore, 1, 2
MAKEMETHOD SCI_STYLESETBACK, 			2052, StyleSetBack, 1, 2
MAKEMETHOD SCI_STYLESETBOLD, 			2053, StyleSetBold, 1, 2
MAKEMETHOD SCI_STYLESETITALIC, 			2054, StyleSetItalic, 1, 2
MAKEMETHOD SCI_STYLESETSIZE, 			2055, StyleSetSize, 1, 2
MAKEMETHOD SCI_STYLESETFONT, 			2056, StyleSetFont, 1, 2
MAKEMETHOD SCI_STYLESETEOLFILLED, 		2057, StyleSetEolFilled, 1, 2
MAKEMETHOD SCI_STYLERESETDEFAULT, 		2058, StyleResetDefault
MAKEMETHOD SCI_STYLESETUNDERLINE, 		2059, StyleSetUnderline, 1, 2
MAKEMETHOD SCI_STYLESETCASE, 			2060, StyleSetCase, 1, 2
MAKEMETHOD SCI_STYLESETCHARACTERSET,	2066, StyleSetCharacterSet, 1, 2
MAKEMETHOD SCI_STYLESETHOTSPOT,			2409, StyleSetHotSpot, 1, 2
MAKEMETHOD SCI_SETSELFORE, 				2067, SetSelFore, 1, 2
MAKEMETHOD SCI_SETSELBACK, 				2068, SetSelBack, 1, 2
MAKEMETHOD SCI_SETCARETFORE, 			2069, SetCaretFore, 1
MAKEMETHOD SCI_ASSIGNCMDKEY, 			2070, AssignCmdKey, 1, 2
MAKEMETHOD SCI_CLEARCMDKEY, 			2071, ClearCmdKey,1
MAKEMETHOD SCI_CLEARALLCMDKEYS, 		2072, ClearAllCmdKeys
MAKEMETHOD SCI_SETSTYLINGEX, 			2073, SetStylingEx,1,2
MAKEMETHOD SCI_STYLESETVISIBLE, 		2074, StyleSetVisible,1,2
MAKEMETHOD SCI_GETCARETPERIOD, 			2075, GetCaretPeriod
MAKEMETHOD SCI_SETCARETPERIOD, 			2076, SetCaretPeriod,1
MAKEMETHOD SCI_SETWORDCHARS, 			2077, SetWordChars,0,1
MAKEMETHOD SCI_BEGINUNDOACTION, 		2078, BeginUndoAction
MAKEMETHOD SCI_ENDUNDOACTION, 			2079, EndUndoAction
MAKEMETHOD SCI_INDICSETSTYLE, 			2080, IndicSetStyle,1,2
MAKEMETHOD SCI_INDICGETSTYLE, 			2081, IndicGetStyle,1
MAKEMETHOD SCI_INDICSETFORE, 			2082, IndicSetFore,1,2
MAKEMETHOD SCI_INDICGETFORE, 			2083, IndicGetFore,1
MAKEMETHOD SCI_SETWHITESPACEFORE,		2084, SetWhiteSpaceFore,1,2
MAKEMETHOD SCI_SETWHITESPACEBACK, 		2085, SetWhiteSpaceBack,1,2
MAKEMETHOD SCI_SETSTYLEBITS, 			2090, SetStyleBits, 1
MAKEMETHOD SCI_GETSTYLEBITS, 			2091, GetStyleBits
MAKEMETHOD SCI_SETLINESTATE, 			2092, SetLineState,1,2
MAKEMETHOD SCI_GETLINESTATE, 			2093, GetLineState,1
MAKEMETHOD SCI_GETMAXLINESTATE, 		2094, GetMaxLineState
MAKEMETHOD SCI_GETCARETLINEVISIBLE, 	2095, GetCaretLineVisible
MAKEMETHOD SCI_SETCARETLINEVISIBLE, 	2096, SetCaretLineVisible,1
MAKEMETHOD SCI_GETCARETLINEBACK, 		2097, GetCaretLineBack
MAKEMETHOD SCI_SETCARETLINEBACK, 		2098, SetCaretLineBack,1
MAKEMETHOD SCI_STYLESETCHANGEABLE,		2099, StyleSetChangeable,1,2
MAKEMETHOD SCI_AUTOCSHOW,				2100, AutoCShow,1,2
MAKEMETHOD SCI_AUTOCCANCEL,				2101, AutoCCancel
MAKEMETHOD SCI_AUTOCACTIVE,				2102, AutoCActive
MAKEMETHOD SCI_AUTOCPOSSTART,			2103, AutoCPosStart
MAKEMETHOD SCI_AUTOCCOMPLETE,			2104, AutoCComplete
MAKEMETHOD SCI_AUTOCSTOPS,				2105, AutoCStops,0,1
MAKEMETHOD SCI_AUTOCSETSEPARATOR,		2106, AutoCSetSeparator,1
MAKEMETHOD SCI_AUTOCGETSEPARATOR,		2107, AutoCGetSeparator
MAKEMETHOD SCI_AUTOCSELECT,				2108, AutoCSelect,0,1
MAKEMETHOD SCI_AUTOCSETCANCELATSTART,	2110, AutoCSetCancelAtStart,1
MAKEMETHOD SCI_AUTOCGETCANCELATSTART,	2111, AutoCGetCancelAtStart
MAKEMETHOD SCI_AUTOCSETFILLUPS,			2112, AutoCSetFillups,0,1
MAKEMETHOD SCI_AUTOCSETCHOOSESINGLE,	2113, AutoCSetChooseSingle,1
MAKEMETHOD SCI_AUTOCGETCHOOSESINGLE,	2114, AutoCGetChooseSingle
MAKEMETHOD SCI_AUTOCSETIGNORECASE,		2115, AutoCSetIgnoreCase,1
MAKEMETHOD SCI_AUTOCGETIGNORECASE,		2116, AutoCGetIgnoreCase
MAKEMETHOD SCI_USERLISTSHOW,			2117, UserListShow,1,2
MAKEMETHOD SCI_AUTOCSETAUTOHIDE,		2118, AutoCSetAutoHide,1
MAKEMETHOD SCI_AUTOCGETAUTOHIDE,		2119, AutoCGetAutoHide
MAKEMETHOD SCI_GETTABWIDTH,				2121, GetTabWidth
MAKEMETHOD SCI_AUTOCSETDROPRESTOFWORD,	2270, AutoCSetDropRestOfWord,1
MAKEMETHOD SCI_AUTOCGETDROPRESTOFWORD,	2271, AutoCGetDropRestOfWord
MAKEMETHOD SCI_REGISTERIMAGE,			2405, RegisterImage
MAKEMETHOD SCI_CLEARREGISTEREDIMAGES,	2408, ClearRegisteredImages
MAKEMETHOD SCI_AUTOCGETTYPESEPARATOR,	2285, AutoCGetTypeSeparator
MAKEMETHOD SCI_AUTOCSETTYPESEPARATOR,	2286, AutoCSetTypeSeparator,1
MAKEMETHOD SCI_AUTOCSETMAXWIDTH,		2208, AutoCSetMaxWidth,1
MAKEMETHOD SCI_AUTOCGETMAXWIDTH,		2209, AutoCGetMaxWidth
MAKEMETHOD SCI_AUTOCSETMAXHEIGHT,		2210, AutoCSetMaxHeight,1
MAKEMETHOD SCI_AUTOCGETMAXHEIGHT,		2211, AutoCGetMaxHeight
MAKEMETHOD SCI_SETINDENT,				2122, SetIndent,1
MAKEMETHOD SCI_GETINDENT,				2123, GetIndent
MAKEMETHOD SCI_SETUSETABS,				2124, SetUseTabs,1
MAKEMETHOD SCI_GETUSETABS,				2125, GetUseTabs
MAKEMETHOD SCI_SETLINEINDENTATION,		2126, SetLineIndentation,1,2
MAKEMETHOD SCI_GETLINEINDENTATION,		2127, GetLineIndentation,1
MAKEMETHOD SCI_GETLINEINDENTPOSITION,	2128, GetLineIndentPosition,1
MAKEMETHOD SCI_GETCOLUMN,				2129, GetColumn, 1
MAKEMETHOD SCI_SETHSCROLLBAR,			2130, SetHScrollBar,1
MAKEMETHOD SCI_GETHSCROLLBAR,			2131, GetHScrollBar
MAKEMETHOD SCI_SETINDENTATIONGUIDES,	2132, SetIndentationGuides,1
MAKEMETHOD SCI_GETINDENTATIONGUIDES,	2133, GetIndentationGuides
MAKEMETHOD SCI_SETHIGHLIGHTGUIDE,		2134, SetHighlightGuide,1
MAKEMETHOD SCI_GETHIGHLIGHTGUIDE,		2135, GetHighlightGuide
MAKEMETHOD SCI_GETLINEENDPOSITION,		2136, GetLineEndPosition,1
MAKEMETHOD SCI_GETCODEPAGE,				2137, GetCodePage
MAKEMETHOD SCI_GETCARETFORE,			2138, GetCaretFore
MAKEMETHOD SCI_GETUSEPALETTE,			2139, GetUsePalette
MAKEMETHOD SCI_GETREADONLY,				2140, GetReadOnly
MAKEMETHOD SCI_SETCURRENTPOS,			2141, SetCurrentPos,1
MAKEMETHOD SCI_SETSELECTIONSTART,		2142, SetSelectionStart, 1
MAKEMETHOD SCI_GETSELECTIONSTART,		2143, GetSelectionStart
MAKEMETHOD SCI_SETSELECTIONEND,			2144, SetSelectionEnd, 1
MAKEMETHOD SCI_GETSELECTIONEND,			2145, GetSelectionEnd
MAKEMETHOD SCI_SETPRINTMAGNIFICATION,	2146, SetPrintMagnification,1
MAKEMETHOD SCI_GETPRINTMAGNIFICATION,	2147, GetPrintMagnification
MAKEMETHOD SCI_SETPRINTCOLOURMODE,		2148, SetPrintColorMode,1
MAKEMETHOD SCI_GETPRINTCOLOURMODE,		2149, GetPrintColorMode
MAKEMETHOD SCI_FINDTEXT,				2150, FindText, 1, 2
MAKEMETHOD SCI_FORMATRANGE,				2151, FormatRange,1,2
MAKEMETHOD SCI_GETFIRSTVISIBLELINE,		2152, GetFirstVisibleLine
MAKEMETHOD SCI_GETLINE,					2153, GetLine,1,2
MAKEMETHOD SCI_GETLINECOUNT,			2154, GetLineCount
MAKEMETHOD SCI_SETMARGINLEFT,			2155, SetMarginLeft,0,1
MAKEMETHOD SCI_GETMARGINLEFT,			2156, GetMarginLeft
MAKEMETHOD SCI_SETMARGINRIGHT,			2157, SetMarginRight,0,1
MAKEMETHOD SCI_GETMARGINRIGHT,			2158, GetMarginRight
MAKEMETHOD SCI_GETMODIFY,				2159, GetModify
MAKEMETHOD SCI_SETSEL,					2160, SetSel, 1,2
MAKEMETHOD SCI_GETSELTEXT,				2161, GetSelText,0,1
MAKEMETHOD SCI_GETTEXTRANGE,			2162, GetTextRange, 0, 1
MAKEMETHOD SCI_HIDESELECTION,			2163, HideSelection,1
MAKEMETHOD SCI_POINTXFROMPOSITION,		2164, PointXFromPosition,0,1
MAKEMETHOD SCI_POINTYFROMPOSITION,		2165, PointYFromPosition,0,1
MAKEMETHOD SCI_LINEFROMPOSITION,		2166, LineFromPosition,1
MAKEMETHOD SCI_POSITIONFROMLINE,		2167, PositionFromLine,1
MAKEMETHOD SCI_LINESCROLL,				2168, LineScroll,1,2
MAKEMETHOD SCI_SCROLLCARET,				2169, ScrollCaret
MAKEMETHOD SCI_REPLACESEL,				2170, ReplaceSel, 0, 1
MAKEMETHOD SCI_SETREADONLY,				2171, SetReadOnly, 1
MAKEMETHOD SCI_NULL,					2172, SciNull
MAKEMETHOD SCI_CANPASTE,				2173, CanPaste
MAKEMETHOD SCI_CANUNDO,					2174, CanUndo
MAKEMETHOD SCI_EMPTYUNDOBUFFER,			2175, EmptyUndoBuffer
MAKEMETHOD SCI_UNDO,					2176, SciUndo
MAKEMETHOD SCI_CUT,						2177, SciCut
MAKEMETHOD SCI_COPY,					2178, SciCopy
MAKEMETHOD SCI_PASTE,					2179, SciPaste
MAKEMETHOD SCI_CLEAR,					2180, SciClear
MAKEMETHOD SCI_SETTEXT,					2181, SciSetText, 0, 1
MAKEMETHOD SCI_GETTEXT,					2182, SciGetText, 1, 2
MAKEMETHOD SCI_GETTEXTLENGTH,			2183, GetTextLength
MAKEMETHOD SCI_GETDIRECTFUNCTION,		2184, GetDirectFunction
MAKEMETHOD SCI_GETDIRECTPOINTER,		2185, GetDirectPointer
MAKEMETHOD SCI_SETOVERTYPE,				2186, SetOverType,1
MAKEMETHOD SCI_GETOVERTYPE,				2187, GetOverType
MAKEMETHOD SCI_SETCARETWIDTH,			2188, SetCaretWidth,1
MAKEMETHOD SCI_GETCARETWIDTH,			2189, GetCaretWidth
MAKEMETHOD SCI_SETTARGETSTART,			2190, SetTargetStart, 1
MAKEMETHOD SCI_GETTARGETSTART,			2191, GetTargetStart
MAKEMETHOD SCI_SETTARGETEND,			2192, SetTargetEnd, 1
MAKEMETHOD SCI_GETTARGETEND,			2193, GetTargetEnd
MAKEMETHOD SCI_REPLACETARGET,			2194, ReplaceInTarget,1,2
MAKEMETHOD SCI_REPLACETARGETRE,			2195, ReplaceTargetRe,1,2
MAKEMETHOD SCI_SEARCHINTARGET,			2197, SearchInTarget, 1,2
MAKEMETHOD SCI_SETSEARCHFLAGS,			2198, SetSearchFlags,1
MAKEMETHOD SCI_GETSEARCHFLAGS,			2199, GetSearchFlags
MAKEMETHOD SCI_CALLTIPSHOW,				2200, CallTipShow,1,2
MAKEMETHOD SCI_CALLTIPCANCEL,			2201, CallTipCancel
MAKEMETHOD SCI_CALLTIPACTIVE,			2202, CallTipActive
MAKEMETHOD SCI_CALLTIPPOSSTART,			2203, CallTipPosStart
MAKEMETHOD SCI_CALLTIPSETHLT,			2204, CallTipSetHlt,1,2
MAKEMETHOD SCI_CALLTIPSETBACK,			2205, CallTipSetBack,1
MAKEMETHOD SCI_CALLTIPSETFORE,			2206, CallTipFore,1
MAKEMETHOD SCI_CALLTIPSETFOREHLT,		2207, CallTipForeHlt,1
MAKEMETHOD SCI_CALLTIPUSESTYLE,			2212, CallTipUseStyle,1
MAKEMETHOD SCI_VISIBLEFROMDOCLINE,		2220, VisibleFromDocLine,1
MAKEMETHOD SCI_DOCLINEFROMVISIBLE,		2221, DocLineFromVisible,1
MAKEMETHOD SCI_WRAPCOUNT,				2235, WrapCount,1
MAKEMETHOD SCI_SETFOLDLEVEL,			2222, SetFoldLevel,1,2
MAKEMETHOD SCI_GETFOLDLEVEL,			2223, GetFoldLevel,1
MAKEMETHOD SCI_GETLASTCHILD,			2224, GetLastChild,1,2
MAKEMETHOD SCI_GETFOLDPARENT,			2225, GetFoldParent,1
MAKEMETHOD SCI_SHOWLINES,				2226, ShowLines,1,2
MAKEMETHOD SCI_HIDELINES,				2227, HideLines,1,2
MAKEMETHOD SCI_GETLINEVISIBLE,			2228, GetLineVisible,1
MAKEMETHOD SCI_SETFOLDEXPANDED,			2229, SetFoldExpanded,1,2
MAKEMETHOD SCI_GETFOLDEXPANDED,			2230, GetFoldExpanded,1
MAKEMETHOD SCI_TOGGLEFOLD,				2231, ToggleFold,1
MAKEMETHOD SCI_ENSUREVISIBLE,			2232, EnsureVisible,1
MAKEMETHOD SCI_SETFOLDFLAGS,			2233, SetFoldFlags,1
MAKEMETHOD SCI_ENSUREVISIBLEENFORCEPOLICY,2234, EnsureVisibleEnforcePolicy,1
MAKEMETHOD SCI_SETTABINDENTS,			2260, SetTabIndents,1
MAKEMETHOD SCI_GETTABINDENTS,			2261, GetTabIndents
MAKEMETHOD SCI_SETBACKSPACEUNINDENTS,	2262, SetBackspaceUnindents,1
MAKEMETHOD SCI_GETBACKSPACEUNINDENTS,	2263, GetBackspaceUnindents
MAKEMETHOD SCI_SETMOUSEDWELLTIME,		2264, SetMouseDwellTime,1
MAKEMETHOD SCI_GETMOUSEDWELLTIME,		2265, GetMouseDwellTime
MAKEMETHOD SCI_WORDSTARTPOSITION,		2266, WordStartPosition,1,2
MAKEMETHOD SCI_WORDENDPOSITION,			2267, WordEndPosition,1,2
MAKEMETHOD SCI_SETWRAPMODE,				2268, SetWrapMode,1
MAKEMETHOD SCI_GETWRAPMODE,				2269, GetWrapMode
MAKEMETHOD SCI_SETWRAPVISUALFLAGS,		2460, SetWrapVisualFlags,1
MAKEMETHOD SCI_GETWRAPVISUALFLAGS,		2461, GetWrapVisualFlags
MAKEMETHOD SCI_SETWRAPVISUALFLAGSLOCATION,2462, SetWrapVisualFlagsLocation,1
MAKEMETHOD SCI_GETWRAPVISUALFLAGSLOCATION,2463, GetWrapVisualFlagsLocation
MAKEMETHOD SCI_SETWRAPSTARTINDENT,		2464, SetWrapStartIndent,1
MAKEMETHOD SCI_GETWRAPSTARTINDENT,		2465, GetWrapStartIndent
MAKEMETHOD SCI_SETLAYOUTCACHE,			2272, SetLayoutCache,1
MAKEMETHOD SCI_GETLAYOUTCACHE,			2273, GetLayoutCache
MAKEMETHOD SCI_SETSCROLLWIDTH,			2274, SetScrollWidth,1
MAKEMETHOD SCI_GETSCROLLWIDTH,			2275, GetScrollWidth
MAKEMETHOD SCI_TEXTWIDTH,				2276, TextWidth,1,2
MAKEMETHOD SCI_SETENDATLASTLINE,		2277, SetEndAtLastLine,1
MAKEMETHOD SCI_GETENDATLASTLINE,		2278, GetEndAtLastLine
MAKEMETHOD SCI_TEXTHEIGHT,				2279, TextHeight,1
MAKEMETHOD SCI_SETVSCROLLBAR,			2280, SetVScrollBar,1
MAKEMETHOD SCI_GETVSCROLLBAR,			2281, GetVScrollBar
MAKEMETHOD SCI_APPENDTEXT,				2282, AppendText, 1, 2
MAKEMETHOD SCI_GETTWOPHASEDRAW,			2283, GetTwoPhaseDraw
MAKEMETHOD SCI_SETTWOPHASEDRAW,			2284, SetTwoPhaseDraw,1
MAKEMETHOD SCI_TARGETFROMSELECTION,		2287, TargetFromSelection
MAKEMETHOD SCI_LINESJOIN,				2288, LinesJoin
MAKEMETHOD SCI_LINESSPLIT,				2289, LinesSplit,1
MAKEMETHOD SCI_SETFOLDMARGINCOLOUR,		2290, SetFoldMarginColor,1,2
MAKEMETHOD SCI_SETFOLDMARGINHICOLOUR,	2291, SetFoldMarginHiColor,1,2
MAKEMETHOD SCI_LINEDOWN,				2300, LineDown
MAKEMETHOD SCI_LINEDOWNEXTEND,			2301, LineDownExtend
MAKEMETHOD SCI_LINEUP,					2302, LineUp
MAKEMETHOD SCI_LINEUPEXTEND,			2303, LineUpExtend
MAKEMETHOD SCI_CHARLEFT,				2304, CharLeft
MAKEMETHOD SCI_CHARLEFTEXTEND,			2305, CharLeftExtend
MAKEMETHOD SCI_CHARRIGHT,				2306, CharRight
MAKEMETHOD SCI_CHARRIGHTEXTEND,			2307, CharRightExtend
MAKEMETHOD SCI_WORDLEFT,				2308, WordLeft
MAKEMETHOD SCI_WORDLEFTEXTEND,			2309, WordLeftExtend
MAKEMETHOD SCI_WORDRIGHT,				2310, WordRight
MAKEMETHOD SCI_WORDRIGHTEXTEND,			2311, WordRightExtend
MAKEMETHOD SCI_HOME,					2312, Home
MAKEMETHOD SCI_HOMEEXTEND,				2313, HomeExtend
MAKEMETHOD SCI_LINEEND,					2314, LineEnd
MAKEMETHOD SCI_LINEENDEXTEND,			2315, LineEndExtend
MAKEMETHOD SCI_DOCUMENTSTART,			2316, DocumentStart
MAKEMETHOD SCI_DOCUMENTSTARTEXTEND,		2317, DocumentStartExtend
MAKEMETHOD SCI_DOCUMENTEND,				2318, DocumentEnd
MAKEMETHOD SCI_DOCUMENTENDEXTEND,		2319, DocumentEndExtend
MAKEMETHOD SCI_PAGEUP,					2320, PageUp
MAKEMETHOD SCI_PAGEUPEXTEND,			2321, PageUpExtend
MAKEMETHOD SCI_PAGEDOWN,				2322, PageDown
MAKEMETHOD SCI_PAGEDOWNEXTEND,			2323, PageDownExtend
MAKEMETHOD SCI_EDITTOGGLEOVERTYPE,		2324, EditToggleOverType
MAKEMETHOD SCI_CANCEL,					2325, Cancel
MAKEMETHOD SCI_DELETEBACK,				2326, DeleteBack
MAKEMETHOD SCI_TAB,						2327, Tab
MAKEMETHOD SCI_BACKTAB,					2328, BackTab
MAKEMETHOD SCI_NEWLINE,					2329, NewLine
MAKEMETHOD SCI_FORMFEED,				2330, FormFeed
MAKEMETHOD SCI_VCHOME,					2331, VcHome
MAKEMETHOD SCI_VCHOMEEXTEND,			2332, VcHomeExtend
MAKEMETHOD SCI_ZOOMIN,					2333, ZoomIn
MAKEMETHOD SCI_ZOOMOUT,					2334, ZoomOut
MAKEMETHOD SCI_DELWORDLEFT,				2335, DeleteWordLeft
MAKEMETHOD SCI_DELWORDRIGHT,			2336, DeleteWordRight
MAKEMETHOD SCI_LINECUT,					2337, LineCut
MAKEMETHOD SCI_LINEDELETE,				2338, LineDelete
MAKEMETHOD SCI_LINETRANSPOSE,			2339, LineTranspose
MAKEMETHOD SCI_LINEDUPLICATE,			2404, LineDuplicate
MAKEMETHOD SCI_LOWERCASE,				2340, LowerCase
MAKEMETHOD SCI_UPPERCASE,				2341, UpperCase
MAKEMETHOD SCI_LINESCROLLDOWN,			2342, LineScrollDown
MAKEMETHOD SCI_LINESCROLLUP,			2343, LineScrollUp
MAKEMETHOD SCI_DELETEBACKNOTLINE,		2344, DeleteBackNotLine
MAKEMETHOD SCI_HOMEDISPLAY,				2345, HomeDisplay
MAKEMETHOD SCI_HOMEDISPLAYEXTEND,		2346, HomeDisplayExtend
MAKEMETHOD SCI_LINEENDDISPLAY,			2347, LineEndDisplay
MAKEMETHOD SCI_LINEENDDISPLAYEXTEND,	2348, LineEndDisplayExtend
MAKEMETHOD SCI_HOMEWRAP,				2349, HomeWrap
MAKEMETHOD SCI_HOMEWRAPEXTEND,			2450, HomeWrapExtend
MAKEMETHOD SCI_LINEENDWRAP,				2451, LineEndWrap
MAKEMETHOD SCI_LINEENDWRAPEXTEND,		2452, LineEndWrapExtend
MAKEMETHOD SCI_VCHOMEWRAP,				2453, VcHomeWrap
MAKEMETHOD SCI_VCHOMEWRAPEXTEND,		2454, VcHomeWrapExtend
MAKEMETHOD SCI_LINECOPY,				2455, LineCopy
MAKEMETHOD SCI_MOVECARETINSIDEVIEW,		2401, MoveCaretInsideView
MAKEMETHOD SCI_LINELENGTH,				2350, LineLength,1
MAKEMETHOD SCI_BRACEHIGHLIGHT,			2351, BraceHighLight,1,2
MAKEMETHOD SCI_BRACEBADLIGHT,			2352, BraceBadLight,1
MAKEMETHOD SCI_BRACEMATCH,				2353, BraceMatch,1,2
MAKEMETHOD SCI_GETVIEWEOL,				2355, GetViewEol
MAKEMETHOD SCI_SETVIEWEOL,				2356, SetViewEol,1
MAKEMETHOD SCI_GETDOCPOINTER,			2357, GetDocPointer
MAKEMETHOD SCI_SETDOCPOINTER,			2358, SetDocPointer,0,1
MAKEMETHOD SCI_SETMODEVENTMASK,			2359, SetModEventMask,1
MAKEMETHOD SCI_GETEDGECOLUMN,			2360, GetEdgeColumn
MAKEMETHOD SCI_SETEDGECOLUMN,			2361, SetEdgeColumn,1
MAKEMETHOD SCI_GETEDGEMODE,				2362, GetEdgeMode
MAKEMETHOD SCI_SETEDGEMODE,				2363, SetEdgeMode,1
MAKEMETHOD SCI_GETEDGECOLOUR,			2364, GetEdgeColor
MAKEMETHOD SCI_SETEDGECOLOUR,			2365, SetEdgeColor,1
MAKEMETHOD SCI_SEARCHANCHOR,			2366, SearchAnchor
MAKEMETHOD SCI_SEARCHNEXT,				2367, SearchNext, 1, 2
MAKEMETHOD SCI_SEARCHPREV,				2368, SearchPrev, 1, 2
MAKEMETHOD SCI_LINESONSCREEN,			2370, LinesOnScreen
MAKEMETHOD SCI_USEPOPUP,				2371, UsePopup,1
MAKEMETHOD SCI_SELECTIONISRECTANGLE,	2372, SelectionIsRectangle
MAKEMETHOD SCI_SETZOOM,					2373, SetZoom,1
MAKEMETHOD SCI_GETZOOM,					2374, GetZoom
MAKEMETHOD SCI_CREATEDOCUMENT,			2375, CreateDocument
MAKEMETHOD SCI_ADDREFDOCUMENT,			2376, AddRefDocument,0,1
MAKEMETHOD SCI_RELEASEDOCUMENT,			2377, ReleaseDocument,0,1
MAKEMETHOD SCI_GETMODEVENTMASK,			2378, GetModEventMask
MAKEMETHOD SCI_SETFOCUS,				2380, SciSetFocus,1
MAKEMETHOD SCI_GETFOCUS,				2381, SciGetFocus
MAKEMETHOD SCI_SETSTATUS,				2382, SetStatus, 1
MAKEMETHOD SCI_GETSTATUS,				2383, GetStatus
MAKEMETHOD SCI_SETMOUSEDOWNCAPTURES,	2384, SetMouseDownCaptures,1
MAKEMETHOD SCI_GETMOUSEDOWNCAPTURES,	2385, GetMouseDownCaptures
MAKEMETHOD SCI_SETCURSOR,				2386, SciSetCursor,1
MAKEMETHOD SCI_GETCURSOR,				2387, SciGetCursor
MAKEMETHOD SCI_SETCONTROLCHARSYMBOL,	2388, SetControlCharSymbol,1
MAKEMETHOD SCI_GETCONTROLCHARSYMBOL,	2389, GetControlCharSymbol
MAKEMETHOD SCI_WORDPARTLEFT,			2390, WordPartLeft
MAKEMETHOD SCI_WORDPARTLEFTEXTEND,		2391, WordPartLeftExtend
MAKEMETHOD SCI_WORDPARTRIGHT,			2392, WordPartRight
MAKEMETHOD SCI_WORDPARTRIGHTEXTEND,		2393, WordPartRightExtend
MAKEMETHOD SCI_SETVISIBLEPOLICY,		2394, SetVisiblePolicy,1,2
MAKEMETHOD SCI_DELLINELEFT,				2395, DeleteLineLeft
MAKEMETHOD SCI_DELLINERIGHT,			2396, DeleteLineRight
MAKEMETHOD SCI_SETXOFFSET,				2397, SetXOffset,1
MAKEMETHOD SCI_GETXOFFSET,				2398, GetXOffset
MAKEMETHOD SCI_CHOOSECARETX,			2399, ChooseCaretX
MAKEMETHOD SCI_GRABFOCUS,				2400, GrabFocus
MAKEMETHOD SCI_SETXCARETPOLICY,			2402, SetXCaretPolicy,1,2
MAKEMETHOD SCI_SETYCARETPOLICY,			2403, SetYCaretPolicy,1,2
MAKEMETHOD SCI_SETPRINTWRAPMODE,		2406, SetPrintWrapMode,1
MAKEMETHOD SCI_GETPRINTWRAPMODE,		2407, GetPrintWrapMode
MAKEMETHOD SCI_SETHOTSPOTACTIVEFORE,	2410, SetHotSpotActiveFore,1,2
MAKEMETHOD SCI_SETHOTSPOTACTIVEBACK,	2411, SetHotSpotActiveBack,1,2
MAKEMETHOD SCI_SETHOTSPOTACTIVEUNDERLINE,2412,SetHotSpotActiveUnderline,1
MAKEMETHOD SCI_SETHOTSPOTSINGLELINE,	2421, SetHotSpotSingleLine,1
MAKEMETHOD SCI_PARADOWN,				2413, ParaDown
MAKEMETHOD SCI_PARADOWNEXTEND,			2414, ParaDownExtend
MAKEMETHOD SCI_PARAUP,					2415, ParaUp
MAKEMETHOD SCI_PARAUPEXTEND,			2416, ParaUpExtend
MAKEMETHOD SCI_POSITIONBEFORE,			2417, PositionBefore,1
MAKEMETHOD SCI_POSITIONAFTER,			2418, PositionAfter,1
MAKEMETHOD SCI_COPYRANGE,				2419, CopyRange, 1,2
MAKEMETHOD SCI_COPYTEXT,				2420, CopyText,1,2
MAKEMETHOD SCI_SETSELECTIONMODE,		2422, SetSelectionMode,1
MAKEMETHOD SCI_GETSELECTIONMODE,		2423, GetSelectionMode
MAKEMETHOD SCI_GETLINESELSTARTPOSITION,	2424, GetLineSelStartPosition,1
MAKEMETHOD SCI_GETLINESELENDPOSITION,	2425, GetLineSelEndPosition,1
MAKEMETHOD SCI_LINEDOWNRECTEXTEND,		2426, LineDownRectExtend
MAKEMETHOD SCI_LINEUPRECTEXTEND,		2427, LineUpRectExtend
MAKEMETHOD SCI_CHARLEFTRECTEXTEND,		2428, CharLeftRectExtend
MAKEMETHOD SCI_CHARRIGHTRECTEXTEND,		2429, CharRightRectExtend
MAKEMETHOD SCI_HOMERECTEXTEND,			2430, HomeRectExtend
MAKEMETHOD SCI_VCHOMERECTEXTEND,		2431, VcHomeRectExtend
MAKEMETHOD SCI_LINEENDRECTEXTEND,		2432, LineEndRectExtend
MAKEMETHOD SCI_PAGEUPRECTEXTEND,		2433, PageUpRectExtend
MAKEMETHOD SCI_PAGEDOWNRECTEXTEND,		2434, PageDownRectExtend
MAKEMETHOD SCI_STUTTEREDPAGEUP,			2435, StutteredPageUp
MAKEMETHOD SCI_STUTTEREDPAGEUPEXTEND,	2436, StutteredPageUpExtend
MAKEMETHOD SCI_STUTTEREDPAGEDOWN,		2437, StutteredPageDown
MAKEMETHOD SCI_STUTTEREDPAGEDOWNEXTEND,	2438, StutteredPageDownExtend
MAKEMETHOD SCI_WORDLEFTEND,				2439, WordLeftEnd
MAKEMETHOD SCI_WORDLEFTENDEXTEND,		2440, WordLeftEndExtend
MAKEMETHOD SCI_WORDRIGHTEND,			2441, WordRightEnd
MAKEMETHOD SCI_WORDRIGHTENDEXTEND,		2442, WordRightEndExtend
MAKEMETHOD SCI_SETWHITESPACECHARS,		2443, SetWhitespaceChars,0,1
MAKEMETHOD SCI_SETCHARSDEFAULT,			2444, SetCharsDefault
MAKEMETHOD SCI_AUTOCGETCURRENT,			2445, AutoCGetCurrent
MAKEMETHOD SCI_ALLOCATE,				2446, Allocate, 1, 0
MAKEMETHOD SCI_TARGETASUTF8,			2447, TargetAsUTF8, 0, 1
MAKEMETHOD SCI_SETLENGTHFORENCODE,		2448, SetLengthForEncode, 1
MAKEMETHOD SCI_ENCODEDFROMUTF8,			2449, EncodedFromUTF8, 1, 2
MAKEMETHOD SCI_FINDCOLUMN,				2456, FindColumn,1,2
MAKEMETHOD SCI_GETCARETSTICKY,			2457, GetCaretSticky
MAKEMETHOD SCI_SETCARETSTICKY,			2458, SetCaretSticky
MAKEMETHOD SCI_TOGGLECARETSTICKY,		2459, ToggleCaretSticky
MAKEMETHOD SCI_SETPASTECONVERTENDINGS,	2467, SetPasteConvertEndings, 1
MAKEMETHOD SCI_GETPASTECONVERTENDINGS,	2468, GetPasteConvertEndings
MAKEMETHOD SCI_SELECTIONDUPLICATE,		2469, SelectionDuplicate
MAKEMETHOD SCI_SETCARETLINEBACKALPHA,	2470, SetCaretLineBackAlpha,1
MAKEMETHOD SCI_GETCARETLINEBACKALPHA,	2471, GetCaretLineBackAlpha
;--------------------------------------------------- SCI_OPTIONAL_START
MAKEMETHOD SCI_STARTRECORD,				3001, StartRecord
MAKEMETHOD SCI_STOPRECORD,				3002, StopRecord
;--------------------------------------------------- SCI_LEXER_START
MAKEMETHOD SCI_SETLEXER,				4001, SetLexer,1
MAKEMETHOD SCI_GETLEXER,				4002, GetLexer
MAKEMETHOD SCI_COLOURISE,				4003, Colorize,1,2
MAKEMETHOD SCI_SETPROPERTY,				4004, SetProperty,1,2
MAKEMETHOD SCI_SETKEYWORDS,				4005, SetKeywords,1,2
MAKEMETHOD SCI_SETLEXERLANGUAGE,		4006, SetLexerLanguage,0,1
MAKEMETHOD SCI_LOADLEXERLIBRARY,		4007, LoadLexerLibrary,0,1
MAKEMETHOD SCI_GETPROPERTY,				4008, GetProperty,1,2
MAKEMETHOD SCI_GETPROPERTYEXPANDED,		4009, GetPropertyExpanded,1,2
MAKEMETHOD SCI_GETPROPERTYINT,			4010, GetPropertyInt,1,2
MAKEMETHOD SCI_GETSTYLEBITSNEEDED,		4011, GetStyleBitsNeeded


;--------------------------------------------------- called from MAKEMETHOD

; __sciexec(q,w,e) = if (m_ptr && m_fn) m_ptr(m_fn,q,w,e)
; __sciexec(q,w)   = if (m_ptr && m_fn) m_ptr(m_fn,q,w)
; __sciexec(q)     = if (m_ptr && m_fn) m_ptr(m_fn,q)

align 4
__sciexec:
	mov  ecx,[eax+sCScintilla.m_fn]
	mov  eax,[eax+sCScintilla.m_ptr]
	pop  edx ; pop return address to method
	push ecx ; scintilla 'this'
	push edx ; return address to method
	and  ecx,ecx
	jz  .err
	and  eax,eax
	jz  .err
	jmp  eax
.err:
	ret

;--------------------------------------------------- WM_NOTIFY
align 4
CScintilla@OnStyleNeeded:
CScintilla@OnCharAdded:
CScintilla@OnSavePointReached:
CScintilla@OnSavePointLeft:
CScintilla@OnModifyAttemtRo:
CScintilla@OnKey:
CScintilla@OnDoubleClick:
CScintilla@OnUpdateUi:
CScintilla@OnModified:
CScintilla@OnMacroRecorded:
CScintilla@OnMarginClick:
CScintilla@OnNeedShown:
CScintilla@OnPainted:
CScintilla@OnUserListSelection:
CScintilla@OnURIDropped:
CScintilla@OnDwellStart:
CScintilla@OnDwellEnd:
CScintilla@OnZoom:
CScintilla@OnHotspotClick:
CScintilla@OnHotspotDoubleClick:
CScintilla@OnCallTipClick:
CScintilla@OnAutoCSelection:
	ret 8

align 4
CScintilla@OnEraseBkgnd:
	mov al,1
	ret 4

;--------------------------------------------------- WM_COMMAND
align 4
CScintilla@OnChange:
CScintilla@OnScSetFocus:
CScintilla@OnScKillFocus:
	ret 4






