%define classname CScintilla
%include "class.inc"
%include "scintilla.inc"

; the class
struc sCScintilla
.m_vtbl  resd 1
.m_hwnd  resd 27 ; aurora CControl members
.m_hSci  resd 1
.m_fn    resd 1
.m_ptr   resd 1 ; cdecl
endstruc

; define vtable offsets
; #define CScintilla_Create 0
; #define CScintilla_Destroy 4
; #define CScintilla_WndProc 8
; ...

INTERFACE CScintilla
	STDMETHOD Create
	STDMETHOD Destroy
	STDMETHOD WndProc
	STDMETHOD OnChar
	STDMETHOD OnClose
	STDMETHOD OnCommand
	STDMETHOD OnControl
	STDMETHOD OnControlColor
	STDMETHOD OnCreate
	STDMETHOD OnDestroy
	STDMETHOD OnDrawItem
	STDMETHOD OnEraseBkgnd
	STDMETHOD OnHScroll
	STDMETHOD OnVScroll
	STDMETHOD OnInitDialog
	STDMETHOD OnKeyDown
	STDMETHOD OnKeyUp
	STDMETHOD OnLButtonDown
	STDMETHOD OnLButtonUp
	STDMETHOD OnLButtonDblClk
	STDMETHOD OnMenuInit
	STDMETHOD OnMenuPick
	STDMETHOD OnMouseMove
	STDMETHOD OnNotify
	STDMETHOD OnPaint
	STDMETHOD OnRButtonDown
	STDMETHOD OnRButtonUp
	STDMETHOD OnRButtonDblClk
	STDMETHOD OnSize
	STDMETHOD OnSizing
	STDMETHOD OnTimer
	STDMETHOD GetHDC
	STDMETHOD ReleaseHDC
	; control
	STDMETHOD SetColor
	STDMETHOD SetText
	STDMETHOD GetText
	; scintilla
	; WM_NOTIFY
	STDMETHOD OnStyleNeeded
	STDMETHOD OnCharAdded
	STDMETHOD OnSavePointReached
	STDMETHOD OnSavePointLeft
	STDMETHOD OnModifyAttemtRo
	STDMETHOD OnKey
	STDMETHOD OnDoubleClick
	STDMETHOD OnUpdateUi
	STDMETHOD OnModified
	STDMETHOD OnMacroRecorded
	STDMETHOD OnMarginClick
	STDMETHOD OnNeedShown
	STDMETHOD OnPainted
	STDMETHOD OnUserListSelection
	STDMETHOD OnURIDropped
	STDMETHOD OnDwellStart
	STDMETHOD OnDwellEnd
	STDMETHOD OnZoom
	STDMETHOD OnHotspotClick
	STDMETHOD OnHotspotDoubleClick
	STDMETHOD OnCallTipClick
	STDMETHOD OnAutoCSelection
	; WM_COMMAND
	STDMETHOD OnChange
	STDMETHOD OnScSetFocus
	STDMETHOD OnScKillFocus
ENDINTERFACE


%macro awindow 1
	extern CWindow@ %+ %1
	dd CWindow@ %+ %1
%endm
%macro acontrol 1
	extern $CControl@ %+ %1
	dd $CControl@ %+ %1
%endm 
%macro scintilla 1
	global $CScintilla@ %+ %1
	dd $CScintilla@ %+ %1
%endm

; create the vtable

segment .data
global CScintilla_vtable_
CScintilla_vtable_:
	scintilla Create
	awindow  Destroy
	awindow  WndProc
	awindow  OnChar
	awindow  OnClose
	awindow  OnCommand
	scintilla  OnControl
	awindow  OnControlColor
	awindow  OnCreate
	scintilla OnDestroy
	awindow  OnDrawItem
	scintilla  OnEraseBkgnd
	awindow  OnHScroll
	awindow  OnVScroll
	awindow  OnInitDialog
	awindow  OnKeyDown
	awindow  OnKeyUp
	awindow  OnLButtonDown
	awindow  OnLButtonUp
	awindow  OnLButtonDblClk
	awindow  OnMenuInit
	awindow  OnMenuPick
	awindow  OnMouseMove
	scintilla  OnNotify
	awindow  OnPaint
	awindow  OnRButtonDown
	awindow  OnRButtonUp
	awindow  OnRButtonDblClk
	scintilla  OnSize
	awindow  OnSizing
	awindow  OnTimer
	awindow  GetHDC
	awindow  ReleaseHDC
	; control
	acontrol SetColor
	scintilla SetText
	scintilla GetText
	; scintilla
	; WM_NOTIFY
	scintilla OnStyleNeeded
	scintilla OnCharAdded
	scintilla OnSavePointReached
	scintilla OnSavePointLeft
	scintilla OnModifyAttemtRo
	scintilla OnKey
	scintilla OnDoubleClick
	scintilla OnUpdateUi
	scintilla OnModified
	scintilla OnMacroRecorded
	scintilla OnMarginClick
	scintilla OnNeedShown
	scintilla OnPainted
	scintilla OnUserListSelection
	scintilla OnURIDropped
	scintilla OnDwellStart
	scintilla OnDwellEnd
	scintilla OnZoom
	scintilla OnHotspotClick
	scintilla OnHotspotDoubleClick
	scintilla OnCallTipClick
	scintilla OnAutoCSelection
	; WM_COMMAND
	scintilla OnChange
	scintilla OnScSetFocus
	scintilla OnScKillFocus

$szControlClassName:	dd "Scintilla"
$szDllName:             dd "scilexer.dll",0

; restore section
segment .text

extern _hinstance



; define a macro for scintilla methods

; MAKEMETHOD SCI_ADDTEXT, 2001, AddText, 1, 2
; produces CScintilla@AddText(x,y) {return __sciexec(2001,x,y);}

; MAKEMETHOD SCI_REDO, 2011, Redo
; produces CScintilla@Redo() {return __sciexec(2011);}

; MAKEMETHOD SCI_GETSTYLEDTEXT, 2015, GetStyledText, 0, 1
; produces CScintilla@GetStyledText(x) {return __sciexec(2015, 0, x);}

; 0 pushes 0
; 1 pushes first argument
; 2 pushes second argument

; __sciexec(q,w,e) = if (m_ptr && m_fn) m_ptr(m_fn,q,w,e)
; __sciexec(q,w)   = if (m_ptr && m_fn) m_ptr(m_fn,q,w)
; __sciexec(q)     = if (m_ptr && m_fn) m_ptr(m_fn,q)

%macro MAKEMETHOD 0-5
	%push makemethod
%if %0 >=3
	align 4
	global CScintilla@ %+ %3
CScintilla@ %+ %3:
	%assign %$pushed 0
	%assign %$args   1
	mov   eax,[esp+4]    ; this
	;--------------------
	; 5 arguments
	;--------------------
	%if %0 = 5
		; 5th argument     this, arg1, arg2
		%if %5 = 0
			push dword 0
		%elif %5 = 1
			push dword[esp+8]
			%assign %$args %$args+1
		%elif %5 = 2
			push dword[esp+12]
			%assign %$args %$args+1
		%endif
		; 4th argument
		%if %4 = 0
			push dword 0
		%elif %4 = 1
			push dword [esp+8+4]
			%assign %$args %$args+1
		%elif %4 = 2
			push dword [esp+12+4]
			%assign %$args %$args+1
		%endif
		%assign %$pushed %$pushed+2
	;--------------------
	; 4 arguments
	;--------------------
	%elif %0 = 4
		; 4th argument     this, arg1
		;	push dword 0
		;	%assign %$pushed %$pushed+1
		%if %4 = 0
			push dword 0
		%elif %4 = 1
			push dword[esp+8]
			%assign %$args %$args+1
		%elif %4 = 2
			push dword[esp+8]
			push dword 0
			%assign %$pushed %$pushed+1
			%assign %$args %$args+1
		%endif
		%assign %$pushed %$pushed+1
	;--------------------
	; 3 arguments
	;--------------------
	%elif %0 = 3
		; no push
	;--------------------
	; 0-2 arguments
	;--------------------
	%else
		%error "bad number of arguments!"
	%endif

	; message
	push  dword %2
	%assign %$pushed %$pushed+1

	; execute
	call __sciexec

	add   esp, (4 * (%$pushed+1))        ; scintilla 'this'
;	ret (%0-2)*4   ; kill 'this' from stack too: (%0-3 +1)*4
	ret (%$args *4)
%endif
	%pop
%endm

